﻿!cpu m65

!source <mega65.asm>

* = $2001
!basic Entry

* = $2016 "Basic Entry"

!source "mega65_io.asm"

Entry
    sei
    lda #$35
    sta $01

    +Enable40Mhz
    +EnableVIC4Registers
    +DisableC65ROM
    +DMACacheEnable

    ;Disable CIA interrupts
    lda #$7f
    sta $dc0d
    sta $dd0d

    ;Disable IRQ raster interrupts
    ;because C65 uses raster interrupts in the ROM
    lda #$00
    sta $d01a

    lda #%00000111
    trb $d016


    ;Set inital screen
    lda #$00
    sta $d020
    sta $d021
    jsr SaveMachineState

    cli

    ;Init music
    lda #$01
    jsr $4000


    jsr RestoreMachineState
    FLOPPY_LOAD $8000, "DEMO1"
    jsr $8000


    jsr RestoreMachineState
    lda #$00
    sta $d418
    sta $d458
    jmp *


PALETTE1 = $7000
PALETTE2 = $7300
PALETTE3 = $7600
PALETTE4 = $7900
VICDATA = $7c00

SaveMachineState:
    ldx #$00
-
    cpx #$2f
    beq .skip
    lda $d000, x
    sta VICDATA, x
  .skip
    inx
    cpx #$7d
    bne -


    lda #%11000000
    trb $d070
    lda #%00000000
    tsb $d070
    ldx #$00
-
    lda $d100, x
    sta PALETTE1, x
    lda $d200, x
    sta PALETTE1 + $100, x
    lda $d300, x
    sta PALETTE1 + $200, x
    dex
    bne -


    lda #%11000000
    trb $d070
    lda #%01000000
    tsb $d070
    ldx #$00
-
    lda $d100, x
    sta PALETTE2, x
    lda $d200, x
    sta PALETTE2 + $100, x
    lda $d300, x
    sta PALETTE2 + $200, x
    dex
    bne -


    lda #%11000000
    trb $d070
    lda #%10000000
    tsb $d070
    ldx #$00
-
    lda $d100, x
    sta PALETTE3, x
    lda $d200, x
    sta PALETTE3 + $100, x
    lda $d300, x
    sta PALETTE3 + $200, x
    dex
    bne -

    lda #%11000000
    trb $d070
    lda #%11000000
    tsb $d070
    ldx #$00
-
    lda $d100, x
    sta PALETTE4, x
    lda $d200, x
    sta PALETTE4 + $100, x
    lda $d300, x
    sta PALETTE4 + $200, x
    dex
    bne -

    rts

RestoreMachineState:
    sei

    +RunDMAJob job1


    lda #%11000000
    trb $d070
    lda #%00000000
    tsb $d070
    +RunDMAJob job2

    lda #%11000000
    trb $d070
    lda #%01000000
    tsb $d070
    +RunDMAJob job3

    lda #%11000000
    trb $d070
    lda #%10000000
    tsb $d070
    +RunDMAJob job4

    lda #%11000000
    trb $d070
    lda #%11000000
    tsb $d070
      +RunDMAJob job5

      +RunDMAJob job6
      +RunDMAJob job7

      cli
    rts

    job1:
      +DMAHeader $00,$ff
      +DMACopyJob VICDATA, $ffd3000, $2f, 1, 0
      +DMACopyJob VICDATA + $30, $ffd3030, $4d, 0, 0
    job2:
      +DMAHeader $00,$ff
      +DMACopyJob PALETTE1, $ffd3100, $300, 0, 0
    job3:
      +DMAHeader $00,$ff
      +DMACopyJob PALETTE2, $ffd3100, $300, 0, 0
    job4:
      +DMAHeader $00,$ff
      +DMACopyJob PALETTE3, $ffd3100, $300, 0, 0
    job5:
      +DMAHeader $00,$ff
      +DMACopyJob PALETTE4, $ffd3100, $300, 0, 0
    job6:
      +DMAHeader $00, $00
      +DMAFillJob $20, $0800, $1800, 0
    job7:
      +DMAHeader $00, $ff
      +DMAFillJob $01, $ff80000, $8000, 0


* = $4000

!bin "demo.sid",,$7e
